Draft Offset/ru: Difference between revisions

From FreeCAD Documentation
(Updating to match new version of source page)
(Updating to match new version of source page)
 
(29 intermediate revisions by 4 users not shown)
Line 1: Line 1:
<languages/>
{{GuiCommand|Name=Draft Offset|Workbenches=[[Draft Module|Draft]], [[Arch Module|Arch]]|MenuLocation=Draft → Offset|Shortcut=O S|SeeAlso=[[Part_Offset2D|Part 2D Offset]]}}


{{Docnav/ru
==Description==
|[[Draft_Mirror/ru|Зеркально отразить]]
|[[Draft_Trimex/ru|Укоротить / Растянуть]]
|[[Draft_Workbench/ru|Верстак Draft]]
|IconL=Draft_Mirror.svg
|IconR=Draft_Trimex.svg
|IconC=Workbench_Draft.svg
}}


{{GuiCommand/ru
The Offset tool offsets the selected object by a given distance on the current [[Draft SelectPlane|work plane]]. If no object is selected, you will be invited to select one.
|Name/ru=Смещение
|Name=Draft_Offset
|MenuLocation=Modification → Смещение
|Workbenches=[[Draft_Workbench/ru|Draft]], [[Arch_Workbench/ru|Arch]]
|Shortcut={{KEY|O}} {{KEY|S}}
|SeeAlso=[[Part_Offset2D/ru|2D смещение...]]
}}

<span id="Description"></span>
==Описание==

The [[Image:Draft_Offset.svg|24px]] '''Draft Offset''' command offsets each segment of a selected object over a given distance, or creates an offset copy of the selected object.


[[Image:Draft_Offset_example.jpg|400px]]
[[Image:Draft_Offset_example.jpg|400px]]
{{Caption|Offsetting a Draft Wire}}


<span id="Usage"></span>
==How to use==
==Применение==


See also: [[Draft_Snap|Draft Snap]] and [[Draft_Constrain|Draft Constrain]].
# Select objects you wish to offset

# Press the {{KEY|[[Image:Draft Offset.png|16px]] [[Draft Offset]]}} button, or press {{KEY|O}} then {{KEY|S}} keys
# Optionally select one object. The object must lie on the current [[Draft_SelectPlane|Draft working plane]].
# Click a point on the 3D view, or type a distance.
# There are several ways to invoke the command:
#* Press the {{Button|[[Image:Draft_Offset.svg|16px]] [[Draft_Offset|Offset]]}} button.
#* Select the {{MenuCommand|Modification → [[Image:Draft_Offset.svg|16px]] Offset}} option from the menu.
#* Use the keyboard shortcut: {{KEY|O}} then {{KEY|S}}.
# If you have not yet selected an object: select an object in the [[3D_view|3D view]].
# The {{MenuCommand|Offset}} task panel opens. See [[#Options|Options]] for more information.
# To define the offset distance do one of the following:
#* Pick a point in the [[3D_view|3D view]].
#* Enter a numerical value:
#*# Make sure the pointer is on the correct side of the object in the [[3D_view|3D view]].
#*# Do not move the pointer out of the [[3D_view|3D view]].
#*# Enter a {{MenuCommand|Distance}}.
#*# Press {{KEY|Enter}} to finish the command.


==Options==
==Options==


The single character keyboard shortcuts available in the task panel can be changed. See [[Draft_Preferences|Draft Preferences]]. The shortcuts mentioned here are the default shortcuts (for version 0.22).
* Press {{KEY|T}} or click the checkbox to check/uncheck the {{KEY|'''Continue'''}} button. If continue mode is on, the Offset tool will restart after you finish or close it, allowing you to offset or copy the objects another time without pressing the Offset button again.
* Pressing {{KEY|ALT}} or {{KEY|C}} or clicking the {{KEY|'''Copy'''}} button will make a copy of the objects, instead of moving them. If you keep {{KEY|ALT}} pressed after clicking the second point, you will be able to place more copies, until you release the {{KEY|ALT}} key.
* Press {{KEY|CTRL}} while drawing to force [[Draft_Snap|snapping]] your point to the nearest snap location, independently of the distance.
* Pressing {{KEY|SHIFT}} will [[Draft_Constrain|constrain]] you to the current segment, instead of picking the closest one.
* Press {{KEY|ESC}} or the {{KEY|'''Cancel'''}} button to abort the current command.


* If the {{MenuCommand|OCC-style offset}} checkbox is checked a special offset style is used: open [[Draft_Wire|Draft Wires]] are offset on both sides, and new edges are connected with rounded corners. This only works for planar objects with at least two edges. Note that with this style a new non-parametric object is created, and if copy mode is off the original object is deleted.
==Scripting==
* Press {{KEY|C}} or click the {{MenuCommand|Copy}} checkbox to toggle copy mode. If copy mode is on, the command will create an offset copy instead of offsetting the original object.
* Holding down {{KEY|Alt}} before picking points in the [[3D_view|3D view]] will also toggle copy mode. While {{KEY|Alt}} is held down multiple offset points can be picked. Release {{KEY|Alt}} to finish the command and see the created copies.
* Hold down {{KEY|Shift}} to keep the offset distance linked to the current segment.
* Press {{KEY|S}} to switch [[Draft_Snap|Draft snapping]] on or off.
* Press {{KEY|Esc}} or the {{Button|Close}} button to abort the command.


<span id="Notes"></span>
The Offset tool can by used in [[macros]] and from the python console by using the following function:
==Примечания==

* To create an offset version of a [[Draft_BSpline|Draft BSpline]] its points are offset individually, and from the new points a new spline is calculated. This new spline is not parallel to the original spline. For an exact parallel offset of a [[Draft_BSpline|Draft BSpline]] the [[Part_Offset2D|Part Offset2D]] command should be used.
* The Draft Offset command cannot handle [[Draft_BezCurve|Draft BezCurves]]. Use the [[Part_Offset2D|Part Offset2D]] command instead.

<span id="Scripting"></span>
==Программирование==

See also: [https://freecad.github.io/SourceDoc/ Autogenerated API documentation] and [[FreeCAD Scripting Basics|FreeCAD Scripting Basics]].

To offset objects use the {{incode|offset}} method of the Draft module. The method can only handle [[Draft_Wire|Draft Wires]], [[Draft_Circle|Draft Circles]], [[Draft_Rectangle|Draft Rectangles]], [[Draft_Polygon|Draft Polygons]] and [[Draft_BSpline|Draft BSplines]].


{{Code|code=
{{Code|code=
offset_obj = offset(obj, delta, copy=False, bind=False, sym=False, occ=False)
offset (object,Vector,[copymode],[bind],[sym])
}}
}}


* {{incode|obj}} is the object to be offset.
* Offsets the given wire by applying the given Vector to its first vertex.
* {{incode|delta}} contains the offset information:
* If copymode is True, another object is created, otherwise the same object gets offsetted.
** For [[Draft_Wire|Draft Wires]], [[Draft_Rectangle|Draft Rectangles]] and [[Draft_Polygon|Draft Polygons]] it is an offset vector that must be perpendicular to the first segment of the object.
* If bind is True, and provided the wire is open, the original and the offsetted wires will be bound by their endpoints, forming a face.
** For [[Draft_Circle|Draft Circles]] it is the new radius.
* If sym is True, the offset is made on both sides, the total width being the length of the given vector.
** For [[Draft_BSpline|Draft BSplines]] it is a list of new points.
* Returns the offsetted object (or its copy if copymode as True).
* If {{incode|copy}} is {{incode|True}} the original object is kept and a new object is created.
* If {{incode|bind}} is {{incode|True}} a face is created by connecting the shape of the original object and the shape of its offset. This only works for open [[Draft_Wire|Draft Wires]].
* If {{incode|sym}} is {{incode|True}}, and {{incode|bind}} is {{incode|True}} as well, the offset is made on both sides of the original object, the total width being the length of the given vector. This only works for open [[Draft_Wire|Draft Wires]].
* If {{incode|occ}} is {{incode|True}} OCC-style offsetting is used. See [[#Options|Options]]. If {{incode|occ}} is {{incode|True}} the {{incode|bind}} and {{incode|sym}} arguments are ignored.
* {{incode|offset_obj}} is returned with the original offset object, or with the new object. If {{incode|bind}} is {{incode|True}} or {{incode|occ}} is {{incode|True}}, the new object is a {{incode|[[Part_Feature|Part::Feature]]}} object.


Пример:
Example:


{{Code|code=
{{Code|code=
import FreeCAD,Draft
import FreeCAD as App
import Draft
Draft.offset(FreeCAD.ActiveDocument.ActiveObject,FreeCAD.Vector(2,2,0))

doc = App.newDocument()

p1 = App.Vector(0, 0, 0)
p2 = App.Vector(1500, 2000, 0)
p3 = App.Vector(4000, 0, 0)

wire = Draft.make_wire([p1, p2, p3])
doc.recompute()

vector = App.Vector(-200, 150, 0)
offset1 = Draft.offset(wire, vector, copy=True, bind=True, sym=True)
offset2 = Draft.offset(wire, 3*vector, copy=True)
offset3 = Draft.offset(wire, 6*vector, copy=True)
offset4 = Draft.offset(wire, 9*vector, copy=True)
offset5 = Draft.offset(wire, 1.5*vector, copy=True, occ=True)

doc.recompute()
}}
}}

<languages/>

{{Docnav/ru
|[[Draft_Mirror/ru|Зеркально отразить]]
|[[Draft_Trimex/ru|Укоротить / Растянуть]]
|[[Draft_Workbench/ru|Верстак Draft]]
|IconL=Draft_Mirror.svg
|IconR=Draft_Trimex.svg
|IconC=Workbench_Draft.svg
}}

{{Draft Tools navi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}

Latest revision as of 04:59, 9 January 2024

Смещение

Системное название
Draft_Offset
Расположение в меню
Modification → Смещение
Верстаки
Draft, Arch
Быстрые клавиши
O S
Представлено в версии
-
См. также
2D смещение...

Описание

The Draft Offset command offsets each segment of a selected object over a given distance, or creates an offset copy of the selected object.

Offsetting a Draft Wire

Применение

See also: Draft Snap and Draft Constrain.

  1. Optionally select one object. The object must lie on the current Draft working plane.
  2. There are several ways to invoke the command:
    • Press the Offset button.
    • Select the Modification → Offset option from the menu.
    • Use the keyboard shortcut: O then S.
  3. If you have not yet selected an object: select an object in the 3D view.
  4. The Offset task panel opens. See Options for more information.
  5. To define the offset distance do one of the following:
    • Pick a point in the 3D view.
    • Enter a numerical value:
      1. Make sure the pointer is on the correct side of the object in the 3D view.
      2. Do not move the pointer out of the 3D view.
      3. Enter a Distance.
      4. Press Enter to finish the command.

Options

The single character keyboard shortcuts available in the task panel can be changed. See Draft Preferences. The shortcuts mentioned here are the default shortcuts (for version 0.22).

  • If the OCC-style offset checkbox is checked a special offset style is used: open Draft Wires are offset on both sides, and new edges are connected with rounded corners. This only works for planar objects with at least two edges. Note that with this style a new non-parametric object is created, and if copy mode is off the original object is deleted.
  • Press C or click the Copy checkbox to toggle copy mode. If copy mode is on, the command will create an offset copy instead of offsetting the original object.
  • Holding down Alt before picking points in the 3D view will also toggle copy mode. While Alt is held down multiple offset points can be picked. Release Alt to finish the command and see the created copies.
  • Hold down Shift to keep the offset distance linked to the current segment.
  • Press S to switch Draft snapping on or off.
  • Press Esc or the Close button to abort the command.

Примечания

  • To create an offset version of a Draft BSpline its points are offset individually, and from the new points a new spline is calculated. This new spline is not parallel to the original spline. For an exact parallel offset of a Draft BSpline the Part Offset2D command should be used.
  • The Draft Offset command cannot handle Draft BezCurves. Use the Part Offset2D command instead.

Программирование

See also: Autogenerated API documentation and FreeCAD Scripting Basics.

To offset objects use the offset method of the Draft module. The method can only handle Draft Wires, Draft Circles, Draft Rectangles, Draft Polygons and Draft BSplines.

offset_obj = offset(obj, delta, copy=False, bind=False, sym=False, occ=False)
  • obj is the object to be offset.
  • delta contains the offset information:
  • If copy is True the original object is kept and a new object is created.
  • If bind is True a face is created by connecting the shape of the original object and the shape of its offset. This only works for open Draft Wires.
  • If sym is True, and bind is True as well, the offset is made on both sides of the original object, the total width being the length of the given vector. This only works for open Draft Wires.
  • If occ is True OCC-style offsetting is used. See Options. If occ is True the bind and sym arguments are ignored.
  • offset_obj is returned with the original offset object, or with the new object. If bind is True or occ is True, the new object is a Part::Feature object.

Пример:

import FreeCAD as App
import Draft

doc = App.newDocument()

p1 = App.Vector(0, 0, 0)
p2 = App.Vector(1500, 2000, 0)
p3 = App.Vector(4000, 0, 0)

wire = Draft.make_wire([p1, p2, p3])
doc.recompute()

vector = App.Vector(-200, 150, 0)
offset1 = Draft.offset(wire, vector, copy=True, bind=True, sym=True)
offset2 = Draft.offset(wire, 3*vector, copy=True)
offset3 = Draft.offset(wire, 6*vector, copy=True)
offset4 = Draft.offset(wire, 9*vector, copy=True)
offset5 = Draft.offset(wire, 1.5*vector, copy=True, occ=True)

doc.recompute()